package cn.taiqing.dsutils;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;

import cn.taiqing.dbpool.EasyDBProxyPool;
import cn.taiqing.dbpool.IEasyDBPool;

/**
 * 数据源工具
 * 提供Connection
 * @author 泰庆
 *
 */
public class DataSourceUtils {
	
	private DataSourceUtils(){};
	
	private static IEasyDBPool dbpool = new EasyDBProxyPool();
	
	public static Connection getConnection(){
		Connection conn = null;
		try {
			conn = dbpool.getConn();
		} catch (SQLException e) {
			throw new RuntimeException(e.getMessage(),e);
		}
		return conn;
	}
	
	public static void setEasyDBPool(IEasyDBPool pool){
		if(pool!=null){
			dbpool = pool;
		}
	}
	
	@Deprecated
	public static DataSource getDataSource(){
		return (DataSource) dbpool;
	}
	
}
