package cn.taiqing.easydb;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import cn.taiqing.dsutils.DataSourceUtils;
import cn.taiqing.easydb.easyhandler.EasyDBHandler;

/**
 * 对数据库增删改查操作
 * 封装成不同类型
 * @author 泰庆
 *
 */
public class EasyDBTemplate {
	
	private Connection con;
	
	public EasyDBTemplate(){
		this.con = DataSourceUtils.getConnection();
	}
	
	public <T> T query(String sql,EasyDBHandler<T> handler){
		T t = null;
		try {
			Statement st = con.createStatement();
			ResultSet rs = st.executeQuery(sql);
			t = handler.handler(rs);
		} catch (SQLException e) {
			throw new RuntimeException(e.getMessage(),e);
		} finally{
			try {
				con.close();
			} catch (SQLException e){
				throw new RuntimeException(e.getMessage(),e);
			}
		}
		return t;
	}
	
	public int insert(String sql){
		return update(sql);
	}
	
	public int delete(String sql){
		return update(sql);
	}
	
	public int update(String sql){
		int result = -1;
		try {
			Statement st = con.createStatement();
			result = st.executeUpdate(sql);
		} catch (SQLException e) {
			throw new RuntimeException(e.getMessage(),e);
		} finally{
			try {
				con.close();
			} catch (SQLException e){
				throw new RuntimeException(e.getMessage(),e);
			}
		}
		return result;
	}
	
}
