package cn.taiqing.easydb.easyhandler.impl;

import java.lang.reflect.Method;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.List;

import cn.taiqing.easydb.easyhandler.EasyDBHandler;

public class EasyDBBeanListHandler<T> implements EasyDBHandler<List<T>> {
	private Class<T> cls;
	public EasyDBBeanListHandler(Class<T> cls) {
		this.cls=cls;
	}
	public List<T> handler(ResultSet rs) {
		List<T> list = new ArrayList<T>();
		try{
			ResultSetMetaData rsmd = rs.getMetaData();
			int cols = rsmd.getColumnCount();
			while(rs.next()){
				T t = cls.newInstance();
				//获取列名
				for(int i=0;i<cols;i++){
					String colName = rsmd.getColumnName(i+1);
					String methodName = 
							"set"+colName.substring(0,1)
							.toUpperCase()
							+colName.substring(1).toLowerCase();
					String javaType = rsmd.getColumnClassName(i+1);
					try{
						Method method = 
								cls.getMethod(methodName, Class.forName(javaType));
						Object val = rs.getObject(i+1);
						method.invoke(t,val);
					}catch(Exception e){}
				}
				list.add(t);
			}
		}catch (Exception e) {
		}
		return list;
	}
}
