package cn.taiqing.easydb.easyhandler.impl;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import cn.taiqing.easydb.easyhandler.EasyDBHandler;


public class EasyDBListMapHandler implements EasyDBHandler<List<Map<String,Object>>>{
	
	public EasyDBListMapHandler(){}
	
	@Override
	public List<Map<String, Object>> handler(ResultSet rs) {
		List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
		try{
			ResultSetMetaData rsmd = rs.getMetaData();
			int cols = rsmd.getColumnCount();
			while(rs.next()){
				Map<String,Object> map = new HashMap<String,Object>();
				for(int i = 0; i < cols; i++){
					String key = rsmd.getColumnName(i+1);
					Object value = rs.getObject(i+1);
					map.put(key, value);
				}
				list.add(map);
			}
			
		}catch(Exception e){
			throw new RuntimeException(e.getMessage(),e);
		}
		return list;
	}
}
