package cn.taiqing.test;

import java.util.List;
import java.util.Map;

import org.junit.Test;

import cn.taiqing.easydb.EasyDBTemplate;
import cn.taiqing.easydb.easyhandler.impl.EasyDBBeanListHandler;
import cn.taiqing.easydb.easyhandler.impl.EasyDBListMapHandler;
import cn.taiqing.utils.UUIDUtil;

/**
 * 对数据库的操作测试
 * @author 泰庆
 *
 */
public class EasyDBTemplateTest {
	
	/**
	 * 测试Update方法
	 * @result
	 *  INSERT INTO students VALUES ('bd5d0d6ba8e34f2888e96a1a5fe5b092','第0名',20,'0',false);
		INSERT INTO students VALUES ('c0450fb7f1044c32817fd0e6c1483c38','第1名',21,'0',false);
		INSERT INTO students VALUES ('765a678102fe4ad9912b97667acd716c','第2名',22,'0',false);
		INSERT INTO students VALUES ('f4e154e317f9438cb6dec27f1ca9d1f5','第3名',23,'0',false);
		INSERT INTO students VALUES ('d02123f79496427193b781892a3a8739','第4名',24,'0',false);
		INSERT INTO students VALUES ('06d4b338137d4fdda4343f52f12f1c42','第5名',25,'0',false);
		INSERT INTO students VALUES ('8e5c8172f31e4696a1fd8b1276e9774f','第6名',26,'0',false);
		INSERT INTO students VALUES ('3460230464014da48cdf9c11929f8009','第7名',27,'0',false);
		INSERT INTO students VALUES ('1af3c0caaa044ef0ae0953c091a0c9b2','第8名',28,'0',false);
		INSERT INTO students VALUES ('52a6dd4558ab4538a1144fb7acf91167','第9名',29,'0',false);
	 */
	@Test
	public void test1(){
		EasyDBTemplate et = new EasyDBTemplate();
		for(int i = 0 ; i < 10 ; i++){
			String sql = "INSERT INTO students VALUES "
					+ "('"+UUIDUtil.getUUID()+"',"
							+ "'第"+i+"名',"
							+(20+i)+","
							+"'0',"
							+false+");";
			System.out.println(sql);
			et.insert(sql);
		}
	}
	
	/**
	 * 测试EasyDBListBeanHandler
	 * @result
	 *  Student [id=bd5d0d6ba8e34f2888e96a1a5fe5b092, name=第0名, age=0, sex=0, iscadre=false]
		Student [id=c0450fb7f1044c32817fd0e6c1483c38, name=第1名, age=0, sex=0, iscadre=false]
		Student [id=765a678102fe4ad9912b97667acd716c, name=第2名, age=0, sex=0, iscadre=false]
		Student [id=f4e154e317f9438cb6dec27f1ca9d1f5, name=第3名, age=0, sex=0, iscadre=false]
		Student [id=d02123f79496427193b781892a3a8739, name=第4名, age=0, sex=0, iscadre=false]
		Student [id=06d4b338137d4fdda4343f52f12f1c42, name=第5名, age=0, sex=0, iscadre=false]
		Student [id=8e5c8172f31e4696a1fd8b1276e9774f, name=第6名, age=0, sex=0, iscadre=false]
		Student [id=3460230464014da48cdf9c11929f8009, name=第7名, age=0, sex=0, iscadre=false]
		Student [id=1af3c0caaa044ef0ae0953c091a0c9b2, name=第8名, age=0, sex=0, iscadre=false]
		Student [id=52a6dd4558ab4538a1144fb7acf91167, name=第9名, age=0, sex=0, iscadre=false]
	 */
	@Test
	public void test2(){
		EasyDBTemplate et = new EasyDBTemplate();
		String sql = "select * from students";
		List<Student> list = et.query(sql, new EasyDBBeanListHandler<Student>(Student.class));
		for(Student stu : list){
			System.out.println(stu);
		}
	}
	/**
	 * 测试EasyDBListMapHandler
	 * @result
	 *  {id=bd5d0d6ba8e34f2888e96a1a5fe5b092, sex=0, iscadre=false, age=20, name=第0名}
		{id=c0450fb7f1044c32817fd0e6c1483c38, sex=0, iscadre=false, age=21, name=第1名}
		{id=765a678102fe4ad9912b97667acd716c, sex=0, iscadre=false, age=22, name=第2名}
		{id=f4e154e317f9438cb6dec27f1ca9d1f5, sex=0, iscadre=false, age=23, name=第3名}
		{id=d02123f79496427193b781892a3a8739, sex=0, iscadre=false, age=24, name=第4名}
		{id=06d4b338137d4fdda4343f52f12f1c42, sex=0, iscadre=false, age=25, name=第5名}
		{id=8e5c8172f31e4696a1fd8b1276e9774f, sex=0, iscadre=false, age=26, name=第6名}
		{id=3460230464014da48cdf9c11929f8009, sex=0, iscadre=false, age=27, name=第7名}
		{id=1af3c0caaa044ef0ae0953c091a0c9b2, sex=0, iscadre=false, age=28, name=第8名}
		{id=52a6dd4558ab4538a1144fb7acf91167, sex=0, iscadre=false, age=29, name=第9名}
	 */
	@Test
	public void test3(){
		EasyDBTemplate et = new EasyDBTemplate();
		String sql = "select * from students";
		List<Map<String,Object>> list = et.query(sql, new EasyDBListMapHandler());
		for(Map<String,Object> map : list)
			System.out.println(map);
	}
	
}
