package cn.taiqing.utils;

import java.io.IOException;
import java.util.Properties;

/**
 * 读取配置文件工具类
 * @author 泰庆
 */
public class PropertiesUtil {
	private PropertiesUtil(){}
	
	private static final String CONFIG_PATH = "jdbc.properties";
	
	public static String DRIVER = null;
	
	public static String URL = null;

	public static String NAME = null;
	
	public static String PWD = null;
	
	public static int POOL_SIZE = 0;
	
	private static Properties prop = new Properties();
	
	static{
		try {
			prop.load(PropertiesUtil.class.getClassLoader().getResourceAsStream(CONFIG_PATH));
			DRIVER = prop.getProperty("driver").trim();
			URL = prop.getProperty("url").trim();
			NAME = prop.getProperty("name").trim();
			PWD = prop.getProperty("pwd").trim();
			POOL_SIZE = Integer.valueOf(prop.getProperty("poolSize").trim());
		} catch (IOException e) {
			throw new RuntimeException(e.getMessage(),e);
		}
	}
	
	public static Properties getConfigProperties(){
		return prop;
	}
}
